package fr.univvalenciennes.publi.application.admin.affichage.jenkov;

import com.jenkov.tags.tree.itf.ITreeIteratorElement;
import com.jenkov.tags.tree.itf.ITreeNode;

import java.util.List;

public class TreeIteratorElement implements ITreeIteratorElement{

    protected ITreeNode node    = null;
    protected List      indentationProfile = null;
    protected boolean   isExpanded = false;
    protected boolean   isSelected = false;
    protected boolean   isFirstChild = false;
    protected boolean   isLastChild  = false;
    /**
     * @deprecated
     */
    protected int       level   = 0 ;

    /**
     * @deprecated
     * @param node
     * @param level
     * @param isExpanded
     * @param isSelected
     * @param isFirstChild
     * @param isLastChild
     */
    public TreeIteratorElement(ITreeNode node, int level,
                               boolean isExpanded  , boolean isSelected,
                               boolean isFirstChild, boolean isLastChild){
        this.node = node;
        this.level= level;
        this.isExpanded   = isExpanded;
        this.isSelected   = isSelected;
        this.isFirstChild = isFirstChild;
        this.isLastChild  = isLastChild;
    }

    public TreeIteratorElement(ITreeNode node, List indentationProfile,
                               boolean isExpanded  , boolean isSelected,
                               boolean isFirstChild, boolean isLastChild){
        this.node = node;
        this.indentationProfile = indentationProfile;
        this.isExpanded   = isExpanded;
        this.isSelected   = isSelected;
        this.isFirstChild = isFirstChild;
        this.isLastChild  = isLastChild;
    }

    public ITreeNode getNode() {
        return this.node;
    }

    public String getId() {
        return getNode().getId();
    }

    public String getName() {
        return getNode().getName();
    }

    public int childLevel() {
        return this.level;
    }

    public List getIndendationProfile() {
        return this.indentationProfile;
    }

    public boolean isExpanded(){
        return this.isExpanded;
    }

    public boolean isSelected() {
        return this.isSelected;
    }

    public boolean isFirstChild() {
        return this.isFirstChild;
    }

    public boolean isLastChild() {
        return this.isLastChild;
    }
}
